Merge branches 'hammer2' and 'master' of ssh://crater.dragonflybsd.org/repository...
[dragonfly.git] / UPDATING
1 # Updating Information for DragonFly users.
2 #
3 #
4 # This file should warn you of any pitfalls which you might need to work around
5 # when trying to update your DragonFly system.  The information below is
6 # in reverse-time order, with the latest information at the top.
7 #
8 # If you discover any problem, please contact the bugs@lists.dragonflybsd.org
9 # mailing list with the details.
10
11 +-----------------------------------------------------------------------+
12 +         UPGRADING DRAGONFLY FROM 3.2 to later versions                +
13 +-----------------------------------------------------------------------+
14
15 SMP OPTION REMOVED
16 ------------------
17
18 The SMP kernel option has been removed. All kernels now feature SMP
19 support. If you have 'options SMP' in your kernel config, you'll have
20 to remove it.
21
22 +-----------------------------------------------------------------------+
23 +         UPGRADING DRAGONFLY FROM 3.0 to later versions                +
24 +-----------------------------------------------------------------------+
25
26 APIC_IO OPTION REMOVED
27 ----------------------
28
29 The APIC_IO kernel option is no longer accepted after having been without
30 effect for a while. The hw.ioapic_enable tunable now serves its purpose.
31 If you have 'options APIC_IO' in your kernel config, you'll have to
32 remove it.
33
34 WATCHDOG_ENABLE & HW_WDOG OPTIONS REMOVED
35 -----------------------------------------
36
37 The wdog framework is now compiled into our kernels by default, so the
38 options are no longer needed.
39
40 DOSCMD(1) REMOVED
41 -----------------
42
43 doscmd(1) has been removed. It was i386 only. The doscmd(1) specific
44 NO_X make.conf option was removed too.
45
46 GCC 4.7
47 -------
48
49 GCC 4.7 has been brought in and replaces GCC 4.1 as DragonFly's non-
50 default compiler in base (default is still GCC 4.4).
51
52 Users who wish to build only GCC 4.4 have to replace NO_GCC41 with
53 NO_GCC47 in /etc/make.conf.
54
55 USB4BSD
56 -------
57
58 A new USB stack (from FreeBSD) has been brought in. The following
59 modules have been ported so far: usb, uhci, ohci, ehci, xhci, umass,
60 usfs, uether, if_axe, if_udav, ukbd, ums, uep, uhid, usb_quirk,
61 and uaudio.
62
63 It is not yet the default. To activate it, WANT_USB4BSD=yes has to
64 be put in make.conf and device "usb4bsd" (quotes needed) has to
65 replace device usb in the kernel config. After that, a full
66 build/install/upgrade cycle is needed.
67
68 Note that this is experimental and incomplete, but we are interested
69 in hearing about issues with it, of course.
70
71 +-----------------------------------------------------------------------+
72 +         UPGRADING DRAGONFLY FROM 2.10 to later versions               +
73 +-----------------------------------------------------------------------+
74
75 SEVERAL ISA DRIVERS REMOVED
76 ---------------------------
77
78 The following ISA only drivers have been removed along with a couple of
79 associated userland tools:
80
81 aha(4)
82 asc(4) & sasc(1)
83 ctx
84 dgb(4)
85 el(4)
86 gpib
87 gsc(4) & sgsc(1)
88 ie(4)
89 labpc(4)
90 le(4)
91 mse(4)
92 rc(4)
93 rdp(4)
94 spigot
95 tw(4) & xten(1) & xtend(8)
96 wl(4) & wlconfig(8)
97 wt(4)
98
99 Note that two of these drivers (aha(4) and ie(4)) are in our GENERIC
100 config and one (aha(4)) is in our X86_64_GENERIC kernel configuration
101 file.
102
103 If buildkernel complains about any of these drivers, just remove them
104 from your kernel configuration.
105
106 BINUTILS 2.20
107 -------------
108 Binutils 2.20 has been removed in favor of Binutils 2.22.  The accepted
109 values of BINUTILSVERS are now binutils221 and binutils222 (default).
110
111 BUILDWORLD/-KERNEL PARALLELIZATION WORK
112 ---------------------------------------
113 Due to changes in the way we build with more than one make job, you
114 will have to update install(1) and mkdir(1) prior to buildworld if you
115 want to build with 'make -j':
116
117 cd /usr/src/usr.bin/xinstall; make; make install; make clean
118 cd /usr/src/bin/mkdir; make; make install; make clean
119
120 DMA(8) UPGRADE
121 --------------
122 dma(8) has been upgraded to v0.7 which no longer supports the
123 /etc/dma/virtusertable. Some of its functionality has been replaced
124 with the MASQUERADE keyword and the EMAIL environment variable (see
125 the dma(8) manual page).
126
127 +-----------------------------------------------------------------------+
128 +         UPGRADING DRAGONFLY FROM 2.8 to later versions                +
129 +-----------------------------------------------------------------------+
130
131 GCC 4.4 & BINUTILS 2.21
132 -----------------------
133
134 GCC 4.4 has been made DragonFly's default compiler and Binutils 2.21 has
135 been made DragonFly's default Binutils.
136
137 That means that any settings that set CCVER to 'gcc44' are not needed
138 anymore. Instead, CCVER can be set to 'gcc41' to go back to using
139 GCC 4.1.
140
141 It also means that 'binutils221' as a value for BINUTILSVER has no
142 effect anymore. 2.17 has been removed and 'binutils220' is available
143 as an option.
144
145 The NO_GCC44 option has been removed and will not affect the build
146 anymore. There is now a NO_GCC41 option that will prevent GCC 4.1 from
147 building in a similar fashion.
148
149 Note that you must do a full buildworld/buildkernel for upgrading.
150
151 pkg_radd settings
152 -----------------
153
154 The config file for pkg_radd has moved from /etc/settings.conf to 
155 /etc/pkg_radd.conf.  Save the contents of settings.conf before upgrading
156 if this is needed.  This warning only applies if /etc/settings.conf 
157 exists.  pkg_radd will continue to work with defaults.
158
159 +-----------------------------------------------------------------------+
160 +         20100927                                                      +
161 +         UPGRADING DRAGONFLY FROM 2.6 to 2.8 or HEAD                   +
162 +-----------------------------------------------------------------------+
163
164 OpenSSL
165 --------
166
167 OpenSSL has been upgraded, and SHLIB_MAJOR was bumped for libssh and libcrypto.
168 This shouldn't break any 3rd-party software, but you'll need to recompile your
169 3rd-party software if you want it to link against the new version of OpenSSL.
170
171 Loader
172 -------
173
174 A new loader (dloader) has been added which better handles booting from
175 multiple kernel/module versions.
176
177 To upgrade (Only for this upgrade, for post 2.8 upgrades see GENERAL below)
178
179         cd /usr/src
180         make buildworld
181         make installworld
182         make upgrade
183         make buildkernel KERNCONF=<KERNELNAME>
184         make installkernel KERNCONF=<KERNELNAME>
185
186 Note that you must installworld and run the 'upgrade' target before
187 installing the new kernel.
188
189 BIND
190 -----
191
192 BIND has been removed from the base system.  The ldns and drill tools have 
193 been added for basic functionality.  Use 'drill' where you would normally 
194 use nslookup or dig, or install BIND from pkgsrc.  It's available as 
195 net/bind95, net/bind96, or net/bind97 as of this writing.
196
197 This only affects older systems upgrading to 2.8.  New 2.8+ installs 
198 include BIND as a pkgsrc package.
199
200 +-----------------------------------------------------------------------+
201 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
202 +                               GENERAL                                 +
203 +-----------------------------------------------------------------------+
204
205 Instructions on how to obtain and maintain DragonFly source code using git
206 are in the development(7) manual page.
207
208 To upgrade a DragonFly system from sources you run the following sequence:
209
210         cd /usr/src
211         make buildworld
212         make buildkernel KERNCONF=<KERNELNAME>
213         make installkernel KERNCONF=<KERNELNAME>
214         make installworld
215
216 You will also want to run the 'upgrade' target to upgrade your /etc and the
217 rest of your system.  The upgrade target is aware of stale files created by
218 older DragonFly installations and should delete them automatically.
219
220         make upgrade
221
222 See the build(7) manual page for further information.
223
224 Once you've done a full build of the world and kernel you can do incremental
225 upgrades of either by using the 'quickworld' and 'quickkernel' targets
226 instead of 'buildworld' and 'buildkernel'.  If you have any problems with
227 the quick targets, try updating your repo first, and then a full buildworld
228 and buildkernel as shown above, before asking for help.
229
230 +-----------------------------------------------------------------------+
231 +         UPGRADING FROM DRAGONFLY <= 2.0 TO DRAGONFLY >= 2.1           +
232 +-----------------------------------------------------------------------+
233
234 In 2.1 kernel and modules has moved to boot directory.  For most cases
235 this is handled automatically by 'make upgrade'.  A few cases needs manual
236 intervention:
237
238  * When installing a kernel without first doing a make buildworld,
239    installworld and upgrade to the same DESTDIR as kernel:
240    make DESTDIR/boot directory and move kernel and modules into this boot
241    directory; also move kernel.old and modules.old.
242    Typical example is vkernel(7), use (no modules used):
243
244         cd /var/vkernel
245         mkdir boot
246         chflags noschg kernel
247         mv kernel kernel.old boot
248         chflags schg boot/kernel
249         
250  * When using a boot-only partition, /boot/loader.rc needs to be edited:
251    delete occurrences of '/boot/'.
252    These occurences can normally be deleted in any case, see loader(8).
253
254 +-----------------------------------------------------------------------+
255 +         UPGRADING FROM DRAGONFLY <= 1.8 TO DRAGONFLY >= 1.9           +
256 +-----------------------------------------------------------------------+
257
258 In 1.9 major changes to the disk management infrastructure have taken
259 place.  make upgrade may not catch all of your disk devices in /dev,
260 so after upgrading be sure to cd /dev; ./MAKEDEV <blah> where <blah>
261 are all of your disk devices.  HOWEVER, from late 2.3 on we run devfs
262 and MAKEDEV no longer exists.
263
264 The biggest changes in 1.9 are:
265
266 (1) That whole-slice devices such as da0s1 no longer share the same device
267     id as partition c devices such as da0s1c.
268
269 (2) The whole-disk device (e.g. da0) is full raw access to the disk,
270     with no snooping or reserved sectors.  Consequently you cannot run
271     disklabel on this device.  Instead you must run disklabel on a
272     whole-slice device.
273
274 (3) The 'compatibility' partitions now use slice 0 in the device name,
275     so instead of da0a you must specify da0s0a.  Also, as per (1) above,
276     accessing the disklabel for the compatibility partitions must be
277     done via slice 0 (da0s0).
278
279 (4) Many device drivers that used to fake up labels, such as CD, ACD, VN,
280     and CCD now run through the disk management layer and are assigned
281     real disk management devices.   VN and CCD in particular do not usually
282     use a MBR and disklabels must be accessed through the compatibility
283     slice 0.  Your /etc/ccd.conf file still specifies 'ccd0', though, you
284     don't name it 'ccd0s0' in the config file.
285
286 Generally speaking, you have to get used to running fdisk and disklabel on
287 the correctly specified device names.  A lot of the wiggle, such as running
288 disklabel on a partition, has been removed.
289
290 +-----------------------------------------------------------------------+
291 +         UPGRADING FROM OLDER VERSIONS OF DRAGONFLY OR FREEBSD         +
292 +-----------------------------------------------------------------------+
293
294 > Kerberos IV
295 -------------
296
297 Kerberos IV (eBones) was removed from the tree, please consider moving to
298 Kerberos 5 (Heimdal).
299
300 > Package Management System
301 ---------------------------
302
303 Starting with the 1.4 release, DragonFly uses NetBSD's pkgsrc package
304 management system.  The necessary tools to build and maintain packages
305 are provided in /usr/pkg/bin and /usr/pkg/sbin.  Make sure that these
306 directories are in your PATH variable.
307
308 In order to obtain a reasonably current snapshot of the pkgsrc tree, use
309 the tarball from NetBSD:
310
311         fetch -o /tmp/pkgsrc.tar.gz ftp://ftp.NetBSD.org/pub/NetBSD/packages/pkgsrc.tar.gz
312         cd /usr; tar -xzf /tmp/pkgsrc.tar.gz; chown -R root:wheel pkgsrc
313
314 This tree can then be kept up to date with cvs update:
315
316         cd /usr/pkgsrc; cvs up
317
318 NOTE! If you upgraded from a pre-1.4 system to 1.4 or later, you need to
319 build and install the pkgsrc bootstrap manually:
320
321         cd /usr/pkgsrc/bootstrap
322         ./bootstrap --pkgdbdir /var/db/pkg --prefix /usr/pkg
323
324 +-----------------------------------------------------------------------+
325 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
326 +         UPDATING FROM PRE-1.2 SYSTEMS OR FreeBSD 4.x TO               +
327 +         DRAGONFLY 1.3+ (EITHER PREVIEW or HEAD)                       +
328 +-----------------------------------------------------------------------+
329
330 The compatibility shims for the build environment have been removed, you
331 have to update to DragonFly 1.2 release branch first.
332
333 The default PAM configuration has moved from /etc/pam.conf to /etc/pam.d/.
334 The existing configuration can be converted using /etc/pam.d/convert.sh.
335 Entries in /etc/pam.d/ override entries in /etc/pam.conf. In addition
336 the pam_skey.so module was retired, you have to remove it manually from
337 your configuration, when you convert it.
338
339 > Required user and group IDs when upgrading from either FreeBSD or DragonFly
340 ---------------------
341
342 The following users may be missing from your password file.  Use vipw and
343 add any that are missing:
344
345 smmsp:*:25:25::0:0:Sendmail Submission User:/var/spool/clientmqueue:/sbin/nologin
346 _pflogd:*:64:64::0:0:pflogd privsep user:/var/empty:/sbin/nologin
347
348 The following groups may be missing from your group file.  Use vi /etc/group
349 and add any that are missing:
350
351 smmsp:*:25:
352 authpf:*:63:
353 _pflogd:*:64:
354
355
356 > Upgrading to DragonFly from FreeBSD
357 ---------------------
358
359 You can build the DragonFly world and DragonFly kernels on a FreeBSD-4.x or
360 FreeBSD-5.x machine and then install DragonFly over FreeBSD, replacing
361 FreeBSD.  Note that the DragonFly buildworld target does not try to reuse
362 make depend information, it starts from scratch, so no pre-cleaning of the
363 object hierarchy is necessary.
364
365         # get the CVS repository (it is placed in /home/dcvs, 500MB).
366         # Please use the -h option and a mirror site to pull the 
367         # initial repository, but feel free to use the main repository
368         # machine to pull updates.
369         cvsup /usr/share/examples/cvsup/DragonFly-cvs-supfile
370         # install the source from the CVS hierarchy (remove preexisting
371         # FreeBSD src first) (500MB)
372         cd /usr
373         rm -rf src
374         cvs -R -d /home/dcvs checkout -P src
375
376         # build it (500MB used in /usr/obj)
377         #
378         cd /usr/src
379         make buildworld
380         make buildkernel KERNCONF=<KERNELNAME>
381
382 Once you have built DragonFly you have to install it over FreeBSD.  Since
383 DragonFly does not track changes made by FreeBSD to its include file 
384 hierarchy and include file pollution can cause all sorts of unexpected
385 compilation issues to come up, it is best to wipe your include hierarchy
386 prior to installing DragonFly.  Note that you should not wipe any installed
387 FreeBSD header files or binaries until after you have successfully completed
388 the build steps above.
389
390         rm -rf /usr/include
391         mkdir /usr/include
392         make installkernel KERNCONF=<KERNELNAME>
393         make installworld
394
395 Then you need to upgrade your system.  DragonFly's 'make upgrade' target 
396 will unconditionally upgrade the /etc files that sysops do not usually
397 mess around with, such as the files in /etc/rc.d.  It will also remove any
398 obsolete files such as utilities and manpages that have been removed from
399 the system since the version you're coming from.  If you are unsure we 
400 recommend that you make a backup of at least your /etc before applying
401 this step.  Note that DragonFly's RC system is basically RCNG from
402 FreeBSD-5, but there are some differences in the contents of the RC files.
403
404         make upgrade
405
406 NOTE! Never do a 'make upgrade' before 'make installworld' has been run.
407 Doing so might leave your system in an unusable state.
408
409 Finally we recommend that you do an 'ls -lta BLAH' for /bin, /sbin, /usr/bin,
410 /usr/bin, and /usr/lib, and remove any stale files that you find.  Please
411 report these files to the DragonFly developers so that they can be added to
412 the 'upgrade' target.
413